/*
	
					The Hacker's Diet

					Unit Conversions
					 
*/

#include "Hackdiet.h"

static double weightConversion[3][3] =
{
/*	Entries for pounds and stones are identical because
	even if stones are selected, entries in log items are
	always kept in pounds.  */

//	To:		kg				lb			st
//	From
/* kg */  { 1.0,		2.2046226,	2.2046226 	},
/* lb */  { 0.45359237,	1.0,		1.0			},
/* st */  { 0.45359237,	1.0,		1.0			}
};			

/*	convertWeight  --  Convert a weight from one unit system to
					   another, if necessary.  */

weight convertWeight(weight w, weightunit from, weightunit to)
{
	if (from != to) {
		w = (weight) ((((double) w) * weightConversion[from][to]) + 0.5);
	}
	
	return w;
}

/*	convertTrend  --  Convert a trend value from one unit system to
					  another, if necessary.  */
					  
trend convertTrend(trend t, weightunit from, weightunit to)
{
	if (from != to) {
		t = (trend) ((((double) t) * weightConversion[from][to]) + 0.5);
	}
	
	return t;
}


/*	convertLong  --  Convert a signed long value between units if necessary.  */

signed long convertLong(signed long l, weightunit from, weightunit to)
{
	if (from != to) {
		l = (signed long) ((((double) l) * weightConversion[from][to]) + 0.5);
	}
	
	return l;
}